'
'Generates a stiffness matrix, and a force vector. then solves the system using LU method
'
'
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
OBJ
   Mat : "MatrixLib"
   Term : "FullDuplexSerial"
   FS : "FloatString" 
VAR
   long k1,k2,k3
   long w1,w2,w3
   
   
Pub Main | K,F,C,D, select, ans

    term.start( 31, 30, 0, 115_200 )
    Mat.clear
    FS.SetPrecision(3)
    K := Mat.Mcreate(3,3)
    F := Mat.Mcreate(3,1)
    k1 := constant(10.0)
    k2 := constant(20.0)
    k3 := constant(30.0)
    w1 := constant(20.0)
    w2 := constant(30.25)
    w3 := constant(15.5)
    fillmats(K,F)

    Term.rx
    repeat
      Term.tx(0)
      Term.str(string("A system of 3 weights, w1,w2,w3 are dangling and conected to each other by springs, k1,k2,k3."))
      Term.tx(13)
      Term.str(string("  Using hooks law [F]=-[K][d] Find the displacements of the weights.  "))
      Term.tx(13)
      Term.tx(13)
      Term.str(string("                   ___"))
      Term.tx(13)
      Term.str(string("                    |"))
      Term.tx(13)
      Term.str(string("                    k1"))
      Term.tx(13)
      Term.str(string("                    |"))
      Term.tx(13)
      Term.str(string("                    m1"))
      Term.tx(13)
      Term.str(string("                    |"))
      Term.tx(13)
      Term.str(string("                    k2"))
      Term.tx(13)
      Term.str(string("                    |"))
      Term.tx(13)
      Term.str(string("                    m2"))
      Term.tx(13)
      Term.str(string("                    |"))
      Term.tx(13)
      Term.str(string("                    k3"))
      Term.tx(13)
      Term.str(string("                    |"))
      Term.tx(13)
      Term.str(string("                    m3"))
      Term.tx(13)
      Term.tx(13)
      Term.str(string("Stiffness Matrix"))
      Term.tx(13) 
      printmat(K)
      Term.tx(13)
      Term.tx(13)
      Term.str(string("Force vector"))
      Term.tx(13) 
      printmat(F)
      Term.tx(13)
      Term.tx(13)
      Term.str(string("Solution [K][d] = [F]"))
      Term.tx(13)
     
      ans := Mat.LUSolve(K,F,1)
      Term.str(string("d1 := ")) 
      term.str( FS.FloatToString(Mat.RFVal(ans,1,1)))
            Term.tx(13)
      Term.str(string("d2 := "))
      term.str( FS.FloatToString(Mat.RFVal(ans,2,1)))
            Term.tx(13)
      Term.str(string("d3 := "))
      term.str( FS.FloatToString(Mat.RFVal(ans,3,1)))
            Term.tx(13)

      repeat

PUB printmat(ptr) | row, col, i, j
      row := Mat.MRow(ptr)'byte[ptr][1]
      col := Mat.MCol(ptr)'byte[ptr][2]
                                                                                          
      Term.tx(13)
      Term.dec(row)
      Term.str(string(" x "))
      Term.dec(col)
      repeat i from 1 to row
        Term.tx(13)
        repeat j from 1 to col 
          Term.str(FS.FloatToString(Mat.RFVal(ptr,i,j)))
          Term.str(string("  "))
PUB fillmats(K,F) | temp, i , j
    

    Mat.WFVal(K,1,1,k1)
    repeat i from 1 to 2
      repeat j from 1 to 2
        if i == j
          temp := Mat.RFVal(K,i,j)
          temp := Mat.addfp(temp,k2)
          Mat.WFVal(K,i,j,temp)
        else
          temp := Mat.RFVal(K,i,j)
          temp := Mat.subfp(temp,k2)
          Mat.WFVal(K,i,j,temp)
    repeat i from 2 to 3
      repeat j from 2 to 3
        if i <> j
          temp := Mat.RFVal(K,i,j)
          temp := Mat.subfp(temp,k3)
          Mat.WFVal(K,i,j,temp)
        else
          temp := Mat.RFVal(K,i,j)
          temp := Mat.addfp(temp,k3)
          Mat.WFVal(K,i,j,temp)  


    Mat.WFVal(F,1,1,w1)
    Mat.WFVal(F,2,1,w2)
    Mat.WFVal(F,3,1,w3)